/*!
 *
 * Copyright (C) 2007 Technical University of Liberec.  All rights reserved.
 *
 * Please make a following refer to Flow123d on your project site if you use the program for any purpose,
 * especially for academic research:
 * Flow123d, Research Centre: Advanced Remedial Technologies, Technical University of Liberec, Czech Republic
 *
 * This program is free software; you can redistribute it and/or modify it under the terms
 * of the GNU General Public License version 3 as published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
 * without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License along with this program; if not,
 * write to the Free Software Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 021110-1307, USA.
 *
 *
 * $Id: ppfcs.h 822 2010-12-17 15:18:04Z jiri.jenicek $
 * $Revision: 822 $
 * $LastChangedBy: jiri.jenicek $
 * $LastChangedDate: 2010-12-17 16:18:04 +0100 (Fri, 17 Dec 2010) $
 *
 * @file
 * @brief ???
 *
 */

#ifndef PPFCS_H
#define PPFCS_H

struct Transport;

#define FOR_ELEMENTCUT(i)        for((i)=transport->fsec->elc;(i)!=NULL;(i)=(i)->next)

//=============================================================================
// STRUCTURE OF THE FLOW-CROSS-SECTION
//=============================================================================
struct FSection
{
		char *fcs_params;
		double      eqn[4] ;    // coef. of x,y,z,1
        int         axis_output;
        int         n_elm;    //  number of FCS elements
        struct  ElementCut    *elc;
};
//=============================================================================
// STRUCTURE OF THE ELEMENT CUT
//=============================================================================
struct ElementCut
{
        ElementIter element;
        int             type; // 1 - side break, 2 - element break
        int             sid;
        int             n_point;
        double          *point[4];     // coord.
        double          cutflux;
        struct ElementCut *next;
        struct ElementCut *prev;
};

#endif
//-----------------------------------------------------------------------------
// vim: set cindent:
