/*!
 *
 * Copyright (C) 2007 Technical University of Liberec.  All rights reserved.
 *
 * Please make a following refer to Flow123d on your project site if you use the program for any purpose,
 * especially for academic research:
 * Flow123d, Research Centre: Advanced Remedial Technologies, Technical University of Liberec, Czech Republic
 *
 * This program is free software; you can redistribute it and/or modify it under the terms
 * of the GNU General Public License version 3 as published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
 * without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License along with this program; if not,
 * write to the Free Software Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 021110-1307, USA.
 *
 *
 * $Id: mesh_types.hh 1054 2011-04-21 13:33:12Z jan.brezina $
 * $Revision: 1054 $
 * $LastChangedBy: jan.brezina $
 * $LastChangedDate: 2011-04-21 15:33:12 +0200 (Thu, 21 Apr 2011) $
 *
 * @file
 * @brief ???
 * @date Aug 6, 2010
 * @author jb
 */

#ifndef MESH_TYPES_HH_
#define MESH_TYPES_HH_

#include "system/sys_vector.hh"

class Node;
class Element;
class Boundary;
class Edge;

// Preparation for next development
typedef flow::VectorId<Node> NodeVector;
typedef NodeVector::Iter NodeIter;
typedef NodeVector::FullIter NodeFullIter;

// iterator over elements
// should be mesh member, but then we have problem how to have ElementIter as memeber of
// Node or other classes without cyclic inclusion
typedef flow::VectorId<Element> ElementVector;
typedef ElementVector::Iter ElementIter;
typedef ElementVector::FullIter ElementFullIter;

typedef flow::VectorId<Boundary> BoundaryVector;
typedef BoundaryVector::Iter BoundaryIter;
typedef BoundaryVector::FullIter BoundaryFullIter;

typedef flow::Vector<Edge> EdgeVector;
typedef EdgeVector::Iter EdgeIter;
typedef EdgeVector::FullIter EdgeFullIter;

#endif /* MESH_TYPES_HH_ */
